/*
 * JBoss, Home of Professional Open Source
 * Copyright 2005, JBoss Inc., and individual contributors as indicated
 * by the @authors tag. See the copyright.txt in the distribution for a
 * full listing of individual contributors.
 *
 * This is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
 */
package org.jboss.test.ws.jaxws.samples.eardeployment;

import java.net.URL;

import javax.wsdl.Definition;
import javax.wsdl.factory.WSDLFactory;
import javax.wsdl.xml.WSDLReader;
import javax.xml.namespace.QName;
import javax.xml.ws.BindingProvider;
import javax.xml.ws.Service;

import junit.framework.Test;

import org.jboss.wsf.test.JBossWSTest;
import org.jboss.wsf.test.JBossWSTestHelper;
import org.jboss.wsf.test.JBossWSTestSetup;

/**
 * Test ear deployment
 * 
 * [JBWS-1616] Verify correct bahaviour of @WebService.wsdlLocation
 *
 * @author Thomas.Diesler@jboss.org
 * @since 08-Dec-2006
 */
public class EarTestCase extends JBossWSTest
{
   public static Test suite()
   {
      String earName = (new JBossWSTestHelper().isTargetJBoss50() ? "jaxws-samples-eardeployment.ear" : "jaxws-samples-eardeployment42.ear");
      return new JBossWSTestSetup(EarTestCase.class, earName);
   }

   public void testEJB3Endpoint() throws Exception
   {
      if (isIntegrationXFire())
      {
         System.out.println("FIXME: [JBWS-1746] - Add support for configurable invoker in cxf.xml");
         return;
      }
      
      String soapAddress = "http://" + getServerHost() + ":8080/earejb3/EJB3Bean";
      QName serviceName = new QName("http://eardeployment.jaxws/", "TestEndpointService");
      Service service = Service.create(new URL(soapAddress + "?wsdl"), serviceName);
      TestEndpoint port = service.getPort(TestEndpoint.class);

      if (!isIntegrationSunRI())
      {
         System.out.println("[JBWS-1616] Verify correct bahaviour of @WebService.wsdlLocation");
         Definition wsdl = getWSDLDefinition(soapAddress + "?wsdl");
         String nsURI = wsdl.getNamespace("jbws1616");
         assertEquals("http://jira.jboss.org/jira/browse/JBWS-1616", nsURI);
      }
      else
      {
         System.out.println("FIXME [JBWS-1616]: Verify correct bahaviour of @WebService.wsdlLocation");
      }

      System.out.println("[JBWS-1655] Add support for endpoint address rewriting");
      BindingProvider bp = (BindingProvider)port;
      bp.getRequestContext().put(BindingProvider.ENDPOINT_ADDRESS_PROPERTY, soapAddress);

      String helloWorld = "Hello world!";
      String retObj = port.echo(helloWorld);
      assertEquals(helloWorld, retObj);
   }

   public void testJSEEndpoint() throws Exception
   {
      String soapAddress = "http://" + getServerHost() + ":8080/earjse/JSEBean";
      QName serviceName = new QName("http://eardeployment.jaxws/", "TestEndpointService");
      Service service = Service.create(new URL(soapAddress + "?wsdl"), serviceName);
      TestEndpoint port = service.getPort(TestEndpoint.class);

      System.out.println("[JBWS-1616] Verify correct bahaviour of @WebService.wsdlLocation");
      Definition wsdl = getWSDLDefinition(soapAddress + "?wsdl");
      String nsURI = wsdl.getNamespace("jbws1616");
      assertEquals("http://jira.jboss.org/jira/browse/JBWS-1616", nsURI);

      System.out.println("[JBWS-1655] Add support for endpoint address rewriting");
      BindingProvider bp = (BindingProvider)port;
      bp.getRequestContext().put(BindingProvider.ENDPOINT_ADDRESS_PROPERTY, soapAddress);

      String helloWorld = "Hello world!";
      String retObj = port.echo(helloWorld);
      assertEquals(helloWorld, retObj);
   }

   private Definition getWSDLDefinition(String wsdlLocation) throws Exception
   {
      WSDLFactory wsdlFactory = WSDLFactory.newInstance();
      WSDLReader wsdlReader = wsdlFactory.newWSDLReader();

      Definition definition = wsdlReader.readWSDL(null, wsdlLocation);
      return definition;
   }
}
